<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MINI51DE_BSP: Nu-LB-Mini51/src/i2c_software_gpio_with_timer.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../M0Banner_v2.jpg"/></td>
  <td id="projectalign">
   <div id="projectname">MINI51DE_BSP<span id="projectnumber">&#160;V3.03.000</span>
   </div>
   <div id="projectbrief">The Board Support Package for Mini51DE Series MCU</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',false,false,'search.php','Search');
});
/* @license-end */
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_2257da8f9ae81bafff8ef39204f6b7df.html">Nu-LB-Mini51</a></li><li class="navelem"><a class="el" href="../../dir_97b8181d9a45c5ab0b3b58a411b81586.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">i2c_software_gpio_with_timer.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**************************************************************************/</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="preprocessor">#include &lt;stdio.h&gt;</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="preprocessor">#include &quot;<a class="code" href="../../dc/da3/i2c__software__gpio__with__timer_8h.html">i2c_software_gpio_with_timer.h</a>&quot;</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span> </div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="comment">/* SDA = GP3.4, CLK = GP3.5 */</span></div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno"><a class="line" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a81d21f1575835add118c879d84cb4abf">   16</a></span><span class="preprocessor">#define I2C_SW_SDA P34</span></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno"><a class="line" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">   17</a></span><span class="preprocessor">#define I2C_SW_CLK P35</span></div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span> </div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno"><a class="line" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a3d006e648a7c1244a98a5417c0420125">   19</a></span><span class="keyword">typedef</span> void (*<a class="code hl_typedef" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a3d006e648a7c1244a98a5417c0420125">TIMER_CALLBACK</a>)(void);</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span> </div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno"><a class="line" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a33904df7e3327767909fc4d4ba9fc2ae">   21</a></span><a class="code hl_typedef" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a3d006e648a7c1244a98a5417c0420125">TIMER_CALLBACK</a> <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a33904df7e3327767909fc4d4ba9fc2ae">funPtr</a>;</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno"><a class="line" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">   22</a></span><a class="code hl_struct" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html">I2C_SW_FLAG_T</a> <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>;</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span> </div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno"><a class="line" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8823849687343e22b66b7f55b7111c59">   24</a></span>uint8_t <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8823849687343e22b66b7f55b7111c59">u8I2C_Buffer</a>;</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno"><a class="line" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a60861a2162622c3c270d28b1d03167bc">   25</a></span>uint8_t* <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a60861a2162622c3c270d28b1d03167bc">p8I2C_Data</a>;</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno"><a class="line" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a5950f60986ee66754eb90475804d227c">   26</a></span>uint32_t <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a5950f60986ee66754eb90475804d227c">u32I2C_ByteSize</a>,<a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a0baccfb6cbba3eac2588de1c5ddb8a6c">u32I2C_ByteSizeCount</a>;</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span> </div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno"><a class="line" href="../../dc/da3/i2c__software__gpio__with__timer_8h.html#ac1f09962a4e8407f58384531270dc131">   33</a></span>uint32_t <a class="code hl_function" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#ac1f09962a4e8407f58384531270dc131">I2C_SW_I_Open</a>(uint32_t u32BusClock)</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>{</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    <span class="comment">/* Setup TIMER0 clock source */</span></div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>    <a class="code hl_define" href="../../dc/ddc/group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKSEL1 = (<a class="code hl_define" href="../../dc/ddc/group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKSEL1 &amp; ~CLK_CLKSEL1_TMR0_S_Msk) | <a class="code hl_define" href="../../d3/de0/group___m_i_n_i51___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga831f1ba136220f44861c047fa802b7b8">CLK_CLKSEL1_TMR0_S_XTAL</a>;</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span> </div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>    <span class="comment">/* Enable TIMER0&#39;s clock */</span></div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>    <a class="code hl_define" href="../../dc/ddc/group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;APBCLK |= <a class="code hl_define" href="../../dd/d47/group___m_i_n_i51___definitions.html#ga8b80ec38b7360db33cd02f423e68eb1d">CLK_APBCLK_TMR0_EN_Msk</a>;</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span> </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>    NVIC_EnableIRQ(<a class="code hl_enumvalue" href="../../da/da1/group___m_i_n_i51___c_m_s_i_s.html#gga666eb0caeb12ec0e281415592ae89083aba7ff2cb6c39f879f4511cfae3bd5513">TMR0_IRQn</a>);</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span> </div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>    <span class="keywordflow">if</span>(u32BusClock&gt;50000)</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>        u32BusClock = 50000;</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span> </div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>    <a class="code hl_define" href="../../de/d02/group___m_i_n_i51___i_o___r_o_u_t_i_n_e.html#ga1a7f814366c290429d1d8d89848335e4">outpw</a>((uint32_t)&amp;<a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>,0);</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>    <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a33904df7e3327767909fc4d4ba9fc2ae">funPtr</a> = <a class="code hl_define" href="../../de/d75/group___m_i_n_i51__legacy___constants.html#ga070d2ce7b6bb7e5c05602aa8c308d0c4">NULL</a>;</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span> </div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>    <a class="code hl_define" href="../../dc/ddc/group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#gaf1b746ba5ab7d0ab657156ebda0f290c">TIMER0</a>-&gt;TCMPR = ((<a class="code hl_define" href="../../dd/d6a/system___mini51_series_8h.html#a273745e210b52623e70b5cdde9010d1a">__IRC22M</a>/2)/ u32BusClock)-1;</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>    <a class="code hl_define" href="../../dc/ddc/group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#gaf1b746ba5ab7d0ab657156ebda0f290c">TIMER0</a>-&gt;TCSR = 0x28000000;</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span> </div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>    <span class="comment">/* Configure P3.4 and P3.5 as open-drain mode */</span></div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>    <a class="code hl_function" href="../../d2/d01/group___m_i_n_i51___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaa2d25bd7fd805f81e465e5f2f0f43123">GPIO_SetMode</a>(<a class="code hl_define" href="../../dc/ddc/group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga0707a89c2f63bd260108e9dbb669358e">P3</a>, 0x30, <a class="code hl_define" href="../../dc/d20/group___m_i_n_i51___g_p_i_o___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga17b71982106eb55ac53e679545791475">GPIO_PMD_OPEN_DRAIN</a>);</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span> </div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>    <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a81d21f1575835add118c879d84cb4abf">I2C_SW_SDA</a> = 1;</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>    <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a> = 1;</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>    <span class="keywordflow">return</span> 0;</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>}</div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span> </div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno"><a class="line" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#af51953d3efc6de255b27b3a471c99d93">   65</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#af51953d3efc6de255b27b3a471c99d93">TMR0_IRQHandler</a>(<span class="keywordtype">void</span>)</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>{</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>    <a class="code hl_define" href="../../dc/ddc/group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#gaf1b746ba5ab7d0ab657156ebda0f290c">TIMER0</a>-&gt;TISR |= <a class="code hl_define" href="../../de/d94/_mini51_series_8h.html#a3fb1aadddedb4cea4eab86779ca4bdce">TIMER_TISR_TIF_Msk</a>;</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span> </div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>    <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a33904df7e3327767909fc4d4ba9fc2ae">funPtr</a>!=<a class="code hl_define" href="../../de/d75/group___m_i_n_i51__legacy___constants.html#ga070d2ce7b6bb7e5c05602aa8c308d0c4">NULL</a>)</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>    {</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>        (*funPtr)();</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>    }</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>}</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span> </div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno"><a class="line" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a219a8c2404f5cb48f32c4d5387c2ccc9">   81</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a219a8c2404f5cb48f32c4d5387c2ccc9">I2C_SW_I_Send_Stop</a>(<span class="keywordtype">void</span>)</div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>{</div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>    <span class="keywordflow">if</span>(<a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a>)</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>    {</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>        <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a81d21f1575835add118c879d84cb4abf">I2C_SW_SDA</a> = 1;</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>        <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#ac21efb773b6ceb2898d437594fefe7e8">STOP</a> = 1;</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>        <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a819c9419f591835332cab0d0ddbfd417">BUSY</a> = 0;</div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>        <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a33904df7e3327767909fc4d4ba9fc2ae">funPtr</a> = <a class="code hl_define" href="../../de/d75/group___m_i_n_i51__legacy___constants.html#ga070d2ce7b6bb7e5c05602aa8c308d0c4">NULL</a>;</div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>    }</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>    <span class="keywordflow">else</span> <span class="keywordflow">if</span>(<a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a81d21f1575835add118c879d84cb4abf">I2C_SW_SDA</a>)</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>    {</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>        <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a81d21f1575835add118c879d84cb4abf">I2C_SW_SDA</a> = 0;</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>    }</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>    {</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>        <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a> = 1;</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>    }</div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>}</div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span> </div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno"><a class="line" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a2616486b326439fd1e2e9f496f671522">  105</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a2616486b326439fd1e2e9f496f671522">I2C_SW_I_Get_Byte</a>(<span class="keywordtype">void</span>)</div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>{</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>    <span class="keywordflow">if</span>(<a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a2aacefbfdf73b4809928d6dca50bcc8a">COUNT</a>&lt;8)</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>    {</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>        <span class="keywordflow">if</span>(<a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a>)</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>        {</div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>            <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8823849687343e22b66b7f55b7111c59">u8I2C_Buffer</a> |= <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a81d21f1575835add118c879d84cb4abf">I2C_SW_SDA</a> &lt;&lt; (7-<a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a2aacefbfdf73b4809928d6dca50bcc8a">COUNT</a>++);</div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>            <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a> = 0;</div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>        }</div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>        {</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>            <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a> = 1;</div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>        }</div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>    }</div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>    {</div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>        <span class="keywordflow">if</span>(<a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a>)</div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>        {</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>            <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a> = 0;</div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>            <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a81d21f1575835add118c879d84cb4abf">I2C_SW_SDA</a> = 1;</div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>            <span class="keywordflow">if</span>(<a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a0baccfb6cbba3eac2588de1c5ddb8a6c">u32I2C_ByteSizeCount</a> == <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a5950f60986ee66754eb90475804d227c">u32I2C_ByteSize</a>)</div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>            {</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>                <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a33904df7e3327767909fc4d4ba9fc2ae">funPtr</a> = <a class="code hl_function" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a219a8c2404f5cb48f32c4d5387c2ccc9">I2C_SW_I_Send_Stop</a>;</div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>            }</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>            <span class="keywordflow">else</span></div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>            {</div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>                <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a2aacefbfdf73b4809928d6dca50bcc8a">COUNT</a> = 0;</div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>                <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8823849687343e22b66b7f55b7111c59">u8I2C_Buffer</a> = 0;</div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>            }</div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>        }</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>        {</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>            *(<a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a60861a2162622c3c270d28b1d03167bc">p8I2C_Data</a> + <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a0baccfb6cbba3eac2588de1c5ddb8a6c">u32I2C_ByteSizeCount</a>++) = <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8823849687343e22b66b7f55b7111c59">u8I2C_Buffer</a>;</div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>            <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a81d21f1575835add118c879d84cb4abf">I2C_SW_SDA</a> = (<a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a0baccfb6cbba3eac2588de1c5ddb8a6c">u32I2C_ByteSizeCount</a> == <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a5950f60986ee66754eb90475804d227c">u32I2C_ByteSize</a>)?1:0;</div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>            <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a> = 1;</div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>        }</div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>    }</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>}</div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span> </div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno"><a class="line" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#aff675fbf5a8e5193004cd54912ef7e0c">  149</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#aff675fbf5a8e5193004cd54912ef7e0c">I2C_SW_I_Send_Byte</a>(<span class="keywordtype">void</span>)</div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span>{</div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>    <span class="keywordflow">if</span>(<a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a2aacefbfdf73b4809928d6dca50bcc8a">COUNT</a>&lt;8)</div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span>    {</div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span>        <span class="keywordflow">if</span>(<a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a>)</div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>        {</div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>            <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a> = 0;</div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span>        }</div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>        {</div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>            <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a81d21f1575835add118c879d84cb4abf">I2C_SW_SDA</a> = <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8823849687343e22b66b7f55b7111c59">u8I2C_Buffer</a> &gt;&gt; (7 - <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a2aacefbfdf73b4809928d6dca50bcc8a">COUNT</a>++);</div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>            <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a> = 1;</div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>        }</div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>    }</div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>    <span class="keywordflow">else</span> <span class="keywordflow">if</span>(<a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a2aacefbfdf73b4809928d6dca50bcc8a">COUNT</a>==8)</div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>    {</div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>        <span class="keywordflow">if</span>(<a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a>)</div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>        {</div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>            <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a> = 0;</div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>        }</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>        {</div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>            <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a81d21f1575835add118c879d84cb4abf">I2C_SW_SDA</a> = 1;</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>            <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a2aacefbfdf73b4809928d6dca50bcc8a">COUNT</a>++;</div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>            <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a> = 1;</div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>        }</div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>    }</div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>    {</div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>        <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a013e0f344e244ac47cfc66b1fb2fad96">NACK</a> = <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a81d21f1575835add118c879d84cb4abf">I2C_SW_SDA</a>;</div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>        <span class="keywordflow">if</span>(<a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a81d21f1575835add118c879d84cb4abf">I2C_SW_SDA</a>)</div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span>        {</div>
<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span>            <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a33904df7e3327767909fc4d4ba9fc2ae">funPtr</a> = <a class="code hl_function" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a219a8c2404f5cb48f32c4d5387c2ccc9">I2C_SW_I_Send_Stop</a>;</div>
<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span>        }</div>
<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span>        <span class="keywordflow">else</span> <span class="keywordflow">if</span>(<a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a6e8ef5045215c0a899d60be207af1639">RW</a>)</div>
<div class="line"><a id="l00184" name="l00184"></a><span class="lineno">  184</span>        {</div>
<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span>            <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a2aacefbfdf73b4809928d6dca50bcc8a">COUNT</a> = 0;</div>
<div class="line"><a id="l00186" name="l00186"></a><span class="lineno">  186</span>            <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8823849687343e22b66b7f55b7111c59">u8I2C_Buffer</a> = 0;</div>
<div class="line"><a id="l00187" name="l00187"></a><span class="lineno">  187</span>            <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a33904df7e3327767909fc4d4ba9fc2ae">funPtr</a> = <a class="code hl_function" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a2616486b326439fd1e2e9f496f671522">I2C_SW_I_Get_Byte</a>;</div>
<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span>        }</div>
<div class="line"><a id="l00189" name="l00189"></a><span class="lineno">  189</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span>        {</div>
<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span>            <span class="keywordflow">if</span>(<a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a0baccfb6cbba3eac2588de1c5ddb8a6c">u32I2C_ByteSizeCount</a> == <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a5950f60986ee66754eb90475804d227c">u32I2C_ByteSize</a>)</div>
<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span>            {</div>
<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span>                <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a33904df7e3327767909fc4d4ba9fc2ae">funPtr</a> = <a class="code hl_function" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a219a8c2404f5cb48f32c4d5387c2ccc9">I2C_SW_I_Send_Stop</a>;</div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span>            }</div>
<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>            <span class="keywordflow">else</span></div>
<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span>            {</div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span>                <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a2aacefbfdf73b4809928d6dca50bcc8a">COUNT</a> = 0;</div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno">  198</span>                <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8823849687343e22b66b7f55b7111c59">u8I2C_Buffer</a> = *(<a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a60861a2162622c3c270d28b1d03167bc">p8I2C_Data</a> + <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a0baccfb6cbba3eac2588de1c5ddb8a6c">u32I2C_ByteSizeCount</a>++);</div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span>            }</div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span>        }</div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span>        <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a> = 0;</div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span>    }</div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span>}</div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span> </div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno"><a class="line" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a676b4875a31f38af2cc8d2454eab4b31">  210</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a676b4875a31f38af2cc8d2454eab4b31">I2C_SW_I_Send_Start</a>(<span class="keywordtype">void</span>)</div>
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>{</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>    <span class="keywordflow">if</span>(<a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a81d21f1575835add118c879d84cb4abf">I2C_SW_SDA</a>)</div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span>    {</div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>        <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a81d21f1575835add118c879d84cb4abf">I2C_SW_SDA</a> = 0;</div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>    }</div>
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span>    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span>    {</div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>        <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a> = 0;</div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span>        <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#ada51c69a841f5ad5cf8432669b25ef8b">START</a> = 1;</div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span>        <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a33904df7e3327767909fc4d4ba9fc2ae">funPtr</a> = <a class="code hl_function" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#aff675fbf5a8e5193004cd54912ef7e0c">I2C_SW_I_Send_Byte</a>;</div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span>    }</div>
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>}</div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span> </div>
<div class="line"><a id="l00232" name="l00232"></a><span class="lineno"><a class="line" href="../../dc/da3/i2c__software__gpio__with__timer_8h.html#ad1718089f74461b7482360f5dd0b284d">  232</a></span>uint32_t <a class="code hl_function" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#ad1718089f74461b7482360f5dd0b284d">I2C_SW_I_Send</a>(uint8_t u8Address, uint8_t* p8Data, uint32_t u32ByteSize)</div>
<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>{</div>
<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span>    <span class="keywordflow">if</span>(<a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a819c9419f591835332cab0d0ddbfd417">BUSY</a>)</div>
<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span>        <span class="keywordflow">return</span> 1;</div>
<div class="line"><a id="l00236" name="l00236"></a><span class="lineno">  236</span> </div>
<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span>    <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a81d21f1575835add118c879d84cb4abf">I2C_SW_SDA</a> = 1;</div>
<div class="line"><a id="l00238" name="l00238"></a><span class="lineno">  238</span>    <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a> = 1;</div>
<div class="line"><a id="l00239" name="l00239"></a><span class="lineno">  239</span> </div>
<div class="line"><a id="l00240" name="l00240"></a><span class="lineno">  240</span>    <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8823849687343e22b66b7f55b7111c59">u8I2C_Buffer</a> = u8Address&lt;&lt;1;</div>
<div class="line"><a id="l00241" name="l00241"></a><span class="lineno">  241</span>    <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a60861a2162622c3c270d28b1d03167bc">p8I2C_Data</a> = p8Data;</div>
<div class="line"><a id="l00242" name="l00242"></a><span class="lineno">  242</span>    <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a5950f60986ee66754eb90475804d227c">u32I2C_ByteSize</a> = u32ByteSize;</div>
<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span>    <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a0baccfb6cbba3eac2588de1c5ddb8a6c">u32I2C_ByteSizeCount</a> = 0;</div>
<div class="line"><a id="l00244" name="l00244"></a><span class="lineno">  244</span> </div>
<div class="line"><a id="l00245" name="l00245"></a><span class="lineno">  245</span>    <a class="code hl_define" href="../../de/d02/group___m_i_n_i51___i_o___r_o_u_t_i_n_e.html#ga1a7f814366c290429d1d8d89848335e4">outpw</a>((uint32_t)&amp;<a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>,0);</div>
<div class="line"><a id="l00246" name="l00246"></a><span class="lineno">  246</span>    <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a819c9419f591835332cab0d0ddbfd417">BUSY</a> = 1;</div>
<div class="line"><a id="l00247" name="l00247"></a><span class="lineno">  247</span>    <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a6e8ef5045215c0a899d60be207af1639">RW</a> = 0;</div>
<div class="line"><a id="l00248" name="l00248"></a><span class="lineno">  248</span>    <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a33904df7e3327767909fc4d4ba9fc2ae">funPtr</a> = <a class="code hl_function" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a676b4875a31f38af2cc8d2454eab4b31">I2C_SW_I_Send_Start</a>;</div>
<div class="line"><a id="l00249" name="l00249"></a><span class="lineno">  249</span> </div>
<div class="line"><a id="l00250" name="l00250"></a><span class="lineno">  250</span>    <a class="code hl_define" href="../../dc/ddc/group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#gaf1b746ba5ab7d0ab657156ebda0f290c">TIMER0</a>-&gt;TCSR |= <a class="code hl_define" href="../../de/d94/_mini51_series_8h.html#a94d08585a4ef3b9104fa1367886bf6ac">TIMER_TCSR_CEN_Msk</a>;</div>
<div class="line"><a id="l00251" name="l00251"></a><span class="lineno">  251</span> </div>
<div class="line"><a id="l00252" name="l00252"></a><span class="lineno">  252</span>    <span class="keywordflow">return</span> 0;</div>
<div class="line"><a id="l00253" name="l00253"></a><span class="lineno">  253</span>}</div>
<div class="line"><a id="l00254" name="l00254"></a><span class="lineno">  254</span> </div>
<div class="line"><a id="l00261" name="l00261"></a><span class="lineno"><a class="line" href="../../dc/da3/i2c__software__gpio__with__timer_8h.html#acef25674042c84614c2e54e26b99275b">  261</a></span>uint32_t <a class="code hl_function" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#acef25674042c84614c2e54e26b99275b">I2C_SW_I_IsBZ</a>(<span class="keywordtype">void</span>)</div>
<div class="line"><a id="l00262" name="l00262"></a><span class="lineno">  262</span>{</div>
<div class="line"><a id="l00263" name="l00263"></a><span class="lineno">  263</span>    <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a819c9419f591835332cab0d0ddbfd417">BUSY</a>;</div>
<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span>}</div>
<div class="line"><a id="l00265" name="l00265"></a><span class="lineno">  265</span> </div>
<div class="line"><a id="l00271" name="l00271"></a><span class="lineno"><a class="line" href="../../dc/da3/i2c__software__gpio__with__timer_8h.html#a92ef1cc8ac1c2a2f3f02ef76eeef8730">  271</a></span>uint32_t <a class="code hl_function" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a92ef1cc8ac1c2a2f3f02ef76eeef8730">I2C_SW_I_Count</a>(<span class="keywordtype">void</span>)</div>
<div class="line"><a id="l00272" name="l00272"></a><span class="lineno">  272</span>{</div>
<div class="line"><a id="l00273" name="l00273"></a><span class="lineno">  273</span>    <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a0baccfb6cbba3eac2588de1c5ddb8a6c">u32I2C_ByteSizeCount</a>;</div>
<div class="line"><a id="l00274" name="l00274"></a><span class="lineno">  274</span>}</div>
<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span> </div>
<div class="line"><a id="l00284" name="l00284"></a><span class="lineno"><a class="line" href="../../dc/da3/i2c__software__gpio__with__timer_8h.html#aedbe35225c1a245d8767f94bda029017">  284</a></span>uint32_t <a class="code hl_function" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#aedbe35225c1a245d8767f94bda029017">I2C_SW_I_Get</a>(uint8_t u8Address, uint8_t* p8Data, uint32_t u32ByteSize)</div>
<div class="line"><a id="l00285" name="l00285"></a><span class="lineno">  285</span>{</div>
<div class="line"><a id="l00286" name="l00286"></a><span class="lineno">  286</span>    <span class="keywordflow">if</span>(<a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a819c9419f591835332cab0d0ddbfd417">BUSY</a>)</div>
<div class="line"><a id="l00287" name="l00287"></a><span class="lineno">  287</span>        <span class="keywordflow">return</span> 1;</div>
<div class="line"><a id="l00288" name="l00288"></a><span class="lineno">  288</span> </div>
<div class="line"><a id="l00289" name="l00289"></a><span class="lineno">  289</span>    <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a81d21f1575835add118c879d84cb4abf">I2C_SW_SDA</a> = 1;</div>
<div class="line"><a id="l00290" name="l00290"></a><span class="lineno">  290</span>    <a class="code hl_define" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a> = 1;</div>
<div class="line"><a id="l00291" name="l00291"></a><span class="lineno">  291</span> </div>
<div class="line"><a id="l00292" name="l00292"></a><span class="lineno">  292</span>    <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8823849687343e22b66b7f55b7111c59">u8I2C_Buffer</a> = (u8Address&lt;&lt;1)+1;</div>
<div class="line"><a id="l00293" name="l00293"></a><span class="lineno">  293</span>    <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a60861a2162622c3c270d28b1d03167bc">p8I2C_Data</a> = p8Data;</div>
<div class="line"><a id="l00294" name="l00294"></a><span class="lineno">  294</span>    <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a5950f60986ee66754eb90475804d227c">u32I2C_ByteSize</a> = u32ByteSize;</div>
<div class="line"><a id="l00295" name="l00295"></a><span class="lineno">  295</span>    <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a0baccfb6cbba3eac2588de1c5ddb8a6c">u32I2C_ByteSizeCount</a> = 0;</div>
<div class="line"><a id="l00296" name="l00296"></a><span class="lineno">  296</span> </div>
<div class="line"><a id="l00297" name="l00297"></a><span class="lineno">  297</span>    <a class="code hl_define" href="../../de/d02/group___m_i_n_i51___i_o___r_o_u_t_i_n_e.html#ga1a7f814366c290429d1d8d89848335e4">outpw</a>((uint32_t)&amp;<a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>,0);</div>
<div class="line"><a id="l00298" name="l00298"></a><span class="lineno">  298</span>    <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a819c9419f591835332cab0d0ddbfd417">BUSY</a> = 1;</div>
<div class="line"><a id="l00299" name="l00299"></a><span class="lineno">  299</span>    <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a>.<a class="code hl_variable" href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a6e8ef5045215c0a899d60be207af1639">RW</a> = 1;</div>
<div class="line"><a id="l00300" name="l00300"></a><span class="lineno">  300</span>    <a class="code hl_variable" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a33904df7e3327767909fc4d4ba9fc2ae">funPtr</a> = <a class="code hl_function" href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a676b4875a31f38af2cc8d2454eab4b31">I2C_SW_I_Send_Start</a>;</div>
<div class="line"><a id="l00301" name="l00301"></a><span class="lineno">  301</span> </div>
<div class="line"><a id="l00302" name="l00302"></a><span class="lineno">  302</span>    <a class="code hl_define" href="../../dc/ddc/group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#gaf1b746ba5ab7d0ab657156ebda0f290c">TIMER0</a>-&gt;TCSR |= <a class="code hl_define" href="../../de/d94/_mini51_series_8h.html#a94d08585a4ef3b9104fa1367886bf6ac">TIMER_TCSR_CEN_Msk</a>;</div>
<div class="line"><a id="l00303" name="l00303"></a><span class="lineno">  303</span> </div>
<div class="line"><a id="l00304" name="l00304"></a><span class="lineno">  304</span>    <span class="keywordflow">return</span> 0;</div>
<div class="line"><a id="l00305" name="l00305"></a><span class="lineno">  305</span>}</div>
<div class="line"><a id="l00306" name="l00306"></a><span class="lineno">  306</span> </div>
<div class="line"><a id="l00307" name="l00307"></a><span class="lineno">  307</span> </div>
<div class="ttc" id="a_mini51_series_8h_html_a3fb1aadddedb4cea4eab86779ca4bdce"><div class="ttname"><a href="../../de/d94/_mini51_series_8h.html#a3fb1aadddedb4cea4eab86779ca4bdce">TIMER_TISR_TIF_Msk</a></div><div class="ttdeci">#define TIMER_TISR_TIF_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d94/_mini51_series_8h_source.html#l04881">Mini51Series.h:4881</a></div></div>
<div class="ttc" id="a_mini51_series_8h_html_a94d08585a4ef3b9104fa1367886bf6ac"><div class="ttname"><a href="../../de/d94/_mini51_series_8h.html#a94d08585a4ef3b9104fa1367886bf6ac">TIMER_TCSR_CEN_Msk</a></div><div class="ttdeci">#define TIMER_TCSR_CEN_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d94/_mini51_series_8h_source.html#l04872">Mini51Series.h:4872</a></div></div>
<div class="ttc" id="agroup___m_i_n_i51___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_ga831f1ba136220f44861c047fa802b7b8"><div class="ttname"><a href="../../d3/de0/group___m_i_n_i51___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga831f1ba136220f44861c047fa802b7b8">CLK_CLKSEL1_TMR0_S_XTAL</a></div><div class="ttdeci">#define CLK_CLKSEL1_TMR0_S_XTAL</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d89/clk_8h_source.html#l00072">clk.h:72</a></div></div>
<div class="ttc" id="agroup___m_i_n_i51___c_m_s_i_s_html_gga666eb0caeb12ec0e281415592ae89083aba7ff2cb6c39f879f4511cfae3bd5513"><div class="ttname"><a href="../../da/da1/group___m_i_n_i51___c_m_s_i_s.html#gga666eb0caeb12ec0e281415592ae89083aba7ff2cb6c39f879f4511cfae3bd5513">TMR0_IRQn</a></div><div class="ttdeci">@ TMR0_IRQn</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d94/_mini51_series_8h_source.html#l00100">Mini51Series.h:100</a></div></div>
<div class="ttc" id="agroup___m_i_n_i51___definitions_html_ga8b80ec38b7360db33cd02f423e68eb1d"><div class="ttname"><a href="../../dd/d47/group___m_i_n_i51___definitions.html#ga8b80ec38b7360db33cd02f423e68eb1d">CLK_APBCLK_TMR0_EN_Msk</a></div><div class="ttdeci">#define CLK_APBCLK_TMR0_EN_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d94/_mini51_series_8h_source.html#l00905">Mini51Series.h:905</a></div></div>
<div class="ttc" id="agroup___m_i_n_i51___g_p_i_o___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_ga17b71982106eb55ac53e679545791475"><div class="ttname"><a href="../../dc/d20/group___m_i_n_i51___g_p_i_o___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga17b71982106eb55ac53e679545791475">GPIO_PMD_OPEN_DRAIN</a></div><div class="ttdeci">#define GPIO_PMD_OPEN_DRAIN</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d7c/gpio_8h_source.html#l00039">gpio.h:39</a></div></div>
<div class="ttc" id="agroup___m_i_n_i51___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gaa2d25bd7fd805f81e465e5f2f0f43123"><div class="ttname"><a href="../../d2/d01/group___m_i_n_i51___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaa2d25bd7fd805f81e465e5f2f0f43123">GPIO_SetMode</a></div><div class="ttdeci">void GPIO_SetMode(GPIO_T *gpio, uint32_t u32PinMask, uint32_t u32Mode)</div><div class="ttdoc">Set GPIO operation mode.</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/da0/gpio_8c_source.html#l00040">gpio.c:40</a></div></div>
<div class="ttc" id="agroup___m_i_n_i51___i_o___r_o_u_t_i_n_e_html_ga1a7f814366c290429d1d8d89848335e4"><div class="ttname"><a href="../../de/d02/group___m_i_n_i51___i_o___r_o_u_t_i_n_e.html#ga1a7f814366c290429d1d8d89848335e4">outpw</a></div><div class="ttdeci">#define outpw(port, value)</div><div class="ttdoc">Set a 32-bit unsigned value to specified I/O port.</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d94/_mini51_series_8h_source.html#l05789">Mini51Series.h:5789</a></div></div>
<div class="ttc" id="agroup___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n_html_ga0707a89c2f63bd260108e9dbb669358e"><div class="ttname"><a href="../../dc/ddc/group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga0707a89c2f63bd260108e9dbb669358e">P3</a></div><div class="ttdeci">#define P3</div><div class="ttdoc">Pointer to GPIO port 3 register structure.</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d94/_mini51_series_8h_source.html#l05741">Mini51Series.h:5741</a></div></div>
<div class="ttc" id="agroup___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n_html_ga4b355291fe6b8ba8e167ab0faa862e45"><div class="ttname"><a href="../../dc/ddc/group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a></div><div class="ttdeci">#define CLK</div><div class="ttdoc">Pointer to CLK register structure.</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d94/_mini51_series_8h_source.html#l05736">Mini51Series.h:5736</a></div></div>
<div class="ttc" id="agroup___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n_html_gaf1b746ba5ab7d0ab657156ebda0f290c"><div class="ttname"><a href="../../dc/ddc/group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#gaf1b746ba5ab7d0ab657156ebda0f290c">TIMER0</a></div><div class="ttdeci">#define TIMER0</div><div class="ttdoc">Pointer to Timer 0 register structure.</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d94/_mini51_series_8h_source.html#l05723">Mini51Series.h:5723</a></div></div>
<div class="ttc" id="agroup___m_i_n_i51__legacy___constants_html_ga070d2ce7b6bb7e5c05602aa8c308d0c4"><div class="ttname"><a href="../../de/d75/group___m_i_n_i51__legacy___constants.html#ga070d2ce7b6bb7e5c05602aa8c308d0c4">NULL</a></div><div class="ttdeci">#define NULL</div><div class="ttdoc">NULL pointer.</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d94/_mini51_series_8h_source.html#l05892">Mini51Series.h:5892</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_a028eb740bf0f553771e7c352fbb21cd7"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a028eb740bf0f553771e7c352fbb21cd7">I2C_SW_CLK</a></div><div class="ttdeci">#define I2C_SW_CLK</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00017">i2c_software_gpio_with_timer.c:17</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_a0baccfb6cbba3eac2588de1c5ddb8a6c"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a0baccfb6cbba3eac2588de1c5ddb8a6c">u32I2C_ByteSizeCount</a></div><div class="ttdeci">uint32_t u32I2C_ByteSizeCount</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00026">i2c_software_gpio_with_timer.c:26</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_a219a8c2404f5cb48f32c4d5387c2ccc9"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a219a8c2404f5cb48f32c4d5387c2ccc9">I2C_SW_I_Send_Stop</a></div><div class="ttdeci">void I2C_SW_I_Send_Stop(void)</div><div class="ttdoc">Send I2C STOP signal.</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00081">i2c_software_gpio_with_timer.c:81</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_a2616486b326439fd1e2e9f496f671522"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a2616486b326439fd1e2e9f496f671522">I2C_SW_I_Get_Byte</a></div><div class="ttdeci">void I2C_SW_I_Get_Byte(void)</div><div class="ttdoc">Read a byte.</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00105">i2c_software_gpio_with_timer.c:105</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_a33904df7e3327767909fc4d4ba9fc2ae"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a33904df7e3327767909fc4d4ba9fc2ae">funPtr</a></div><div class="ttdeci">TIMER_CALLBACK funPtr</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00021">i2c_software_gpio_with_timer.c:21</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_a3d006e648a7c1244a98a5417c0420125"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a3d006e648a7c1244a98a5417c0420125">TIMER_CALLBACK</a></div><div class="ttdeci">void(* TIMER_CALLBACK)(void)</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00019">i2c_software_gpio_with_timer.c:19</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_a5950f60986ee66754eb90475804d227c"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a5950f60986ee66754eb90475804d227c">u32I2C_ByteSize</a></div><div class="ttdeci">uint32_t u32I2C_ByteSize</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00026">i2c_software_gpio_with_timer.c:26</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_a60861a2162622c3c270d28b1d03167bc"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a60861a2162622c3c270d28b1d03167bc">p8I2C_Data</a></div><div class="ttdeci">uint8_t * p8I2C_Data</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00025">i2c_software_gpio_with_timer.c:25</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_a676b4875a31f38af2cc8d2454eab4b31"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a676b4875a31f38af2cc8d2454eab4b31">I2C_SW_I_Send_Start</a></div><div class="ttdeci">void I2C_SW_I_Send_Start(void)</div><div class="ttdoc">Send I2C START signal.</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00210">i2c_software_gpio_with_timer.c:210</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_a81d21f1575835add118c879d84cb4abf"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a81d21f1575835add118c879d84cb4abf">I2C_SW_SDA</a></div><div class="ttdeci">#define I2C_SW_SDA</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00016">i2c_software_gpio_with_timer.c:16</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_a8823849687343e22b66b7f55b7111c59"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8823849687343e22b66b7f55b7111c59">u8I2C_Buffer</a></div><div class="ttdeci">uint8_t u8I2C_Buffer</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00024">i2c_software_gpio_with_timer.c:24</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_a8b06394ff9c2c1a20dd018325b46462a"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a8b06394ff9c2c1a20dd018325b46462a">I2C_SW_STATUS</a></div><div class="ttdeci">I2C_SW_FLAG_T I2C_SW_STATUS</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00022">i2c_software_gpio_with_timer.c:22</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_a92ef1cc8ac1c2a2f3f02ef76eeef8730"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#a92ef1cc8ac1c2a2f3f02ef76eeef8730">I2C_SW_I_Count</a></div><div class="ttdeci">uint32_t I2C_SW_I_Count(void)</div><div class="ttdoc">Return byte counter.</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00271">i2c_software_gpio_with_timer.c:271</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_ac1f09962a4e8407f58384531270dc131"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#ac1f09962a4e8407f58384531270dc131">I2C_SW_I_Open</a></div><div class="ttdeci">uint32_t I2C_SW_I_Open(uint32_t u32BusClock)</div><div class="ttdoc">Prepare to start software I2C.</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00033">i2c_software_gpio_with_timer.c:33</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_acef25674042c84614c2e54e26b99275b"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#acef25674042c84614c2e54e26b99275b">I2C_SW_I_IsBZ</a></div><div class="ttdeci">uint32_t I2C_SW_I_IsBZ(void)</div><div class="ttdoc">Check if I2C is busy.</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00261">i2c_software_gpio_with_timer.c:261</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_ad1718089f74461b7482360f5dd0b284d"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#ad1718089f74461b7482360f5dd0b284d">I2C_SW_I_Send</a></div><div class="ttdeci">uint32_t I2C_SW_I_Send(uint8_t u8Address, uint8_t *p8Data, uint32_t u32ByteSize)</div><div class="ttdoc">Send data.</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00232">i2c_software_gpio_with_timer.c:232</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_aedbe35225c1a245d8767f94bda029017"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#aedbe35225c1a245d8767f94bda029017">I2C_SW_I_Get</a></div><div class="ttdeci">uint32_t I2C_SW_I_Get(uint8_t u8Address, uint8_t *p8Data, uint32_t u32ByteSize)</div><div class="ttdoc">Read data.</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00284">i2c_software_gpio_with_timer.c:284</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_af51953d3efc6de255b27b3a471c99d93"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#af51953d3efc6de255b27b3a471c99d93">TMR0_IRQHandler</a></div><div class="ttdeci">void TMR0_IRQHandler(void)</div><div class="ttdoc">ISR to handle TIMER0 interrupt event.</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00065">i2c_software_gpio_with_timer.c:65</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8c_html_aff675fbf5a8e5193004cd54912ef7e0c"><div class="ttname"><a href="../../d2/dcc/i2c__software__gpio__with__timer_8c.html#aff675fbf5a8e5193004cd54912ef7e0c">I2C_SW_I_Send_Byte</a></div><div class="ttdeci">void I2C_SW_I_Send_Byte(void)</div><div class="ttdoc">Send a byte.</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcc/i2c__software__gpio__with__timer_8c_source.html#l00149">i2c_software_gpio_with_timer.c:149</a></div></div>
<div class="ttc" id="ai2c__software__gpio__with__timer_8h_html"><div class="ttname"><a href="../../dc/da3/i2c__software__gpio__with__timer_8h.html">i2c_software_gpio_with_timer.h</a></div><div class="ttdoc">This is the header file of i2c_software_gpio_with_timer.c.</div></div>
<div class="ttc" id="astruct_i2_c___s_w___f_l_a_g___t_html"><div class="ttname"><a href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html">I2C_SW_FLAG_T</a></div><div class="ttdef"><b>Definition:</b> <a href="../../dc/da3/i2c__software__gpio__with__timer_8h_source.html#l00017">i2c_software_gpio_with_timer.h:18</a></div></div>
<div class="ttc" id="astruct_i2_c___s_w___f_l_a_g___t_html_a013e0f344e244ac47cfc66b1fb2fad96"><div class="ttname"><a href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a013e0f344e244ac47cfc66b1fb2fad96">I2C_SW_FLAG_T::NACK</a></div><div class="ttdeci">uint32_t NACK</div><div class="ttdef"><b>Definition:</b> <a href="../../dc/da3/i2c__software__gpio__with__timer_8h_source.html#l00020">i2c_software_gpio_with_timer.h:20</a></div></div>
<div class="ttc" id="astruct_i2_c___s_w___f_l_a_g___t_html_a2aacefbfdf73b4809928d6dca50bcc8a"><div class="ttname"><a href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a2aacefbfdf73b4809928d6dca50bcc8a">I2C_SW_FLAG_T::COUNT</a></div><div class="ttdeci">uint32_t COUNT</div><div class="ttdef"><b>Definition:</b> <a href="../../dc/da3/i2c__software__gpio__with__timer_8h_source.html#l00019">i2c_software_gpio_with_timer.h:19</a></div></div>
<div class="ttc" id="astruct_i2_c___s_w___f_l_a_g___t_html_a6e8ef5045215c0a899d60be207af1639"><div class="ttname"><a href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a6e8ef5045215c0a899d60be207af1639">I2C_SW_FLAG_T::RW</a></div><div class="ttdeci">uint32_t RW</div><div class="ttdef"><b>Definition:</b> <a href="../../dc/da3/i2c__software__gpio__with__timer_8h_source.html#l00023">i2c_software_gpio_with_timer.h:23</a></div></div>
<div class="ttc" id="astruct_i2_c___s_w___f_l_a_g___t_html_a819c9419f591835332cab0d0ddbfd417"><div class="ttname"><a href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#a819c9419f591835332cab0d0ddbfd417">I2C_SW_FLAG_T::BUSY</a></div><div class="ttdeci">uint32_t BUSY</div><div class="ttdef"><b>Definition:</b> <a href="../../dc/da3/i2c__software__gpio__with__timer_8h_source.html#l00024">i2c_software_gpio_with_timer.h:24</a></div></div>
<div class="ttc" id="astruct_i2_c___s_w___f_l_a_g___t_html_ac21efb773b6ceb2898d437594fefe7e8"><div class="ttname"><a href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#ac21efb773b6ceb2898d437594fefe7e8">I2C_SW_FLAG_T::STOP</a></div><div class="ttdeci">uint32_t STOP</div><div class="ttdef"><b>Definition:</b> <a href="../../dc/da3/i2c__software__gpio__with__timer_8h_source.html#l00022">i2c_software_gpio_with_timer.h:22</a></div></div>
<div class="ttc" id="astruct_i2_c___s_w___f_l_a_g___t_html_ada51c69a841f5ad5cf8432669b25ef8b"><div class="ttname"><a href="../../da/da8/struct_i2_c___s_w___f_l_a_g___t.html#ada51c69a841f5ad5cf8432669b25ef8b">I2C_SW_FLAG_T::START</a></div><div class="ttdeci">uint32_t START</div><div class="ttdef"><b>Definition:</b> <a href="../../dc/da3/i2c__software__gpio__with__timer_8h_source.html#l00021">i2c_software_gpio_with_timer.h:21</a></div></div>
<div class="ttc" id="asystem___mini51_series_8h_html_a273745e210b52623e70b5cdde9010d1a"><div class="ttname"><a href="../../dd/d6a/system___mini51_series_8h.html#a273745e210b52623e70b5cdde9010d1a">__IRC22M</a></div><div class="ttdeci">#define __IRC22M</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/d6a/system___mini51_series_8h_source.html#l00031">system_Mini51Series.h:31</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Oct 18 2024 18:23:38 for MINI51DE_BSP by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
